-- Copyright (C) 2009  Carlo A. Furia
--                     caf@inf.ethz.ch  http://se.inf.ethz.ch/people/furia/
--                     
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.


class BOOGIEPL_SCANNER

inherit

   YY_COMPRESSED_SCANNER_SKELETON

   BOOGIEPL_TOKEN_CODES

create

   make_with_given_filename

feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= comment)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 37 then
if yy_act <= 19 then
if yy_act <= 10 then
if yy_act <= 5 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
--|#line 29 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 29")
end
line_nb := line_nb + 1
else
--|#line 33 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 33")
end
set_start_condition (comment)
end
else
--|#line 34 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 34")
end
-- Eat anything that's not a '*'
end
else
if yy_act = 4 then
--|#line 35 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 35")
end
-- Eat up '*'s not followed by '/'s
else
--|#line 36 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 36")
end
line_nb := line_nb + 1
end
end
else
if yy_act <= 8 then
if yy_act <= 7 then
if yy_act = 6 then
--|#line 37 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 37")
end
set_start_condition (INITIAL)
else
--|#line 40 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 40")
end
-- Discards blanks
end
else
--|#line 43 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 43")
end
line_nb := line_nb + 1
end
else
if yy_act = 9 then
--|#line 47 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 47")
end
 last_string_value := text; last_token := ASSERTKW 
else
--|#line 48 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 48")
end
 last_string_value := text; last_token := ASSUMEKW 
end
end
end
else
if yy_act <= 15 then
if yy_act <= 13 then
if yy_act <= 12 then
if yy_act = 11 then
--|#line 49 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 49")
end
 last_string_value := text; last_token := AXIOMKW 
else
--|#line 50 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 50")
end
 last_string_value := text; last_token := BOOLKW 
end
else
--|#line 51 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 51")
end
 last_string_value := text; last_token := BREAKKW 
end
else
if yy_act = 14 then
--|#line 52 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 52")
end
 last_string_value := text; last_token := CALLKW 
else
--|#line 53 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 53")
end
 last_string_value := text; last_token := COMPLETEKW 
end
end
else
if yy_act <= 17 then
if yy_act = 16 then
--|#line 54 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 54")
end
 last_string_value := text; last_token := CONSTKW 
else
--|#line 55 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 55")
end
 last_string_value := text; last_token := ELSEKW 
end
else
if yy_act = 18 then
--|#line 56 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 56")
end
 last_string_value := text; last_token := ENSURESKW 
else
--|#line 57 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 57")
end
 last_string_value := text; last_token := EXISTSKW 
end
end
end
end
else
if yy_act <= 28 then
if yy_act <= 24 then
if yy_act <= 22 then
if yy_act <= 21 then
if yy_act = 20 then
--|#line 58 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 58")
end
 last_string_value := text; last_token := FALSEKW 
else
--|#line 59 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 59")
end
 last_string_value := text; last_token := FINITEKW 
end
else
--|#line 60 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 60")
end
 last_string_value := text; last_token := FORALLKW 
end
else
if yy_act = 23 then
--|#line 61 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 61")
end
 last_string_value := text; last_token := FREEKW 
else
--|#line 62 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 62")
end
 last_string_value := text; last_token := FUNCTIONKW 
end
end
else
if yy_act <= 26 then
if yy_act = 25 then
--|#line 63 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 63")
end
 last_string_value := text; last_token := GOTOKW 
else
--|#line 64 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 64")
end
 last_string_value := text; last_token := HAVOCKW 
end
else
if yy_act = 27 then
--|#line 65 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 65")
end
 last_string_value := text; last_token := IFKW 
else
--|#line 66 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 66")
end
 last_string_value := text; last_token := IMPLEMENTATIONKW 
end
end
end
else
if yy_act <= 33 then
if yy_act <= 31 then
if yy_act <= 30 then
if yy_act = 29 then
--|#line 67 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 67")
end
 last_string_value := text; last_token := INTKW 
else
--|#line 68 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 68")
end
 last_string_value := text; last_token := INVARIANTKW 
end
else
--|#line 69 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 69")
end
 last_string_value := text; last_token := MODIFIESKW 
end
else
if yy_act = 32 then
--|#line 70 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 70")
end
 last_string_value := text; last_token := OLDKW 
else
--|#line 71 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 71")
end
 last_string_value := text; last_token := PROCEDUREKW 
end
end
else
if yy_act <= 35 then
if yy_act = 34 then
--|#line 72 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 72")
end
 last_string_value := text; last_token := REQUIRESKW 
else
--|#line 73 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 73")
end
 last_string_value := text; last_token := RETURNKW 
end
else
if yy_act = 36 then
--|#line 74 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 74")
end
 last_string_value := text; last_token := RETURNSKW 
else
--|#line 75 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 75")
end
 last_string_value := text; last_token := TRUEKW 
end
end
end
end
end
else
if yy_act <= 56 then
if yy_act <= 47 then
if yy_act <= 42 then
if yy_act <= 40 then
if yy_act <= 39 then
if yy_act = 38 then
--|#line 76 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 76")
end
 last_string_value := text; last_token := TYPEKW 
else
--|#line 77 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 77")
end
 last_string_value := text; last_token := UNIQUEKW 
end
else
--|#line 78 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 78")
end
 last_string_value := text; last_token := VARKW 
end
else
if yy_act = 41 then
--|#line 79 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 79")
end
 last_string_value := text; last_token := WHEREKW 
else
--|#line 80 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 80")
end
 last_string_value := text; last_token := WHILEKW 
end
end
else
if yy_act <= 45 then
if yy_act <= 44 then
if yy_act = 43 then
--|#line 82 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 82")
end
 last_string_value := text; last_token := ASSIGNEMENTKW 
else
--|#line 83 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 83")
end
 last_string_value := text; last_token := EQUALKW 
end
else
--|#line 84 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 84")
end
 last_string_value := text; last_token := NEQUALKW 
end
else
if yy_act = 46 then
--|#line 85 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 85")
end
 last_string_value := text; last_token := LESSTHANKW 
else
--|#line 86 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 86")
end
 last_string_value := text; last_token := GREATERTHANKW 
end
end
end
else
if yy_act <= 52 then
if yy_act <= 50 then
if yy_act <= 49 then
if yy_act = 48 then
--|#line 87 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 87")
end
 last_string_value := text; last_token := LESSTHANOREQUALTOKW 
else
--|#line 88 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 88")
end
 last_string_value := text; last_token := GREATERTHANOREQUALTOKW 
end
else
--|#line 89 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 89")
end
 last_string_value := text; last_token := PRECEDESKW 
end
else
if yy_act = 51 then
--|#line 91 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 91")
end
 last_string_value := text; last_token := DOUBLECOLONKW 
else
--|#line 93 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 93")
end
 last_string_value := text; last_token := IFFKW 
end
end
else
if yy_act <= 54 then
if yy_act = 53 then
--|#line 94 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 94")
end
 last_string_value := text; last_token := IMPLIESKW 
else
--|#line 95 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 95")
end
 last_string_value := text; last_token := ANDKW 
end
else
if yy_act = 55 then
--|#line 96 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 96")
end
 last_string_value := text; last_token := ORKW 
else
--|#line 99 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 99")
end
 last_string_value := text; last_token := OPENBRACKETKW 
end
end
end
end
else
if yy_act <= 65 then
if yy_act <= 61 then
if yy_act <= 59 then
if yy_act <= 58 then
if yy_act = 57 then
--|#line 100 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 100")
end
 last_string_value := text; last_token := CLOSEDBRACKETKW 
else
--|#line 101 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 101")
end
 last_string_value := text; last_token := COMMAKW 
end
else
--|#line 102 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 102")
end
 last_string_value := text; last_token := OPENPARENKW 
end
else
if yy_act = 60 then
--|#line 103 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 103")
end
 last_string_value := text; last_token := CLOSEDPARENKW 
else
--|#line 104 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 104")
end
 last_string_value := text; last_token := COLONKW 
end
end
else
if yy_act <= 63 then
if yy_act = 62 then
--|#line 105 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 105")
end
 last_string_value := text; last_token := PLUSKW 
else
--|#line 106 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 106")
end
 last_string_value := text; last_token := MINUSKW 
end
else
if yy_act = 64 then
--|#line 107 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 107")
end
 last_string_value := text; last_token := TIMESKW 
else
--|#line 108 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 108")
end
 last_string_value := text; last_token := DIVIDEKW 
end
end
end
else
if yy_act <= 70 then
if yy_act <= 68 then
if yy_act <= 67 then
if yy_act = 66 then
--|#line 109 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 109")
end
 last_string_value := text; last_token := PERCENTKW 
else
--|#line 110 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 110")
end
 last_string_value := text; last_token := BANGKW 
end
else
--|#line 111 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 111")
end
 last_string_value := text; last_token := SEMICOLONKW 
end
else
if yy_act = 69 then
--|#line 112 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 112")
end
 last_string_value := text; last_token := EQUALSIGNKW 
else
--|#line 113 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 113")
end
 last_string_value := text; last_token := CURLYOPENKW 
end
end
else
if yy_act <= 72 then
if yy_act = 71 then
--|#line 114 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 114")
end
 last_string_value := text; last_token := CURLYCLOSEDKW 
else
--|#line 122 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 122")
end
 last_string_value := text; last_token := IDID 
end
else
if yy_act = 73 then
--|#line 126 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 126")
end
 last_string_value := text; last_token := NUM 
else
--|#line 0 "boogiepl.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'boogiepl.l' at line 0")
end
default_action
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			terminate
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   10,   26,   27,   28,   29,   30,   10,   31,   32,
			   33,   34,   35,   10,   10,   36,   10,   37,   38,   10,
			   39,   10,   40,   41,   42,   43,   10,   10,   44,   45,
			   46,   48,   48,   54,  104,  105,   67,   55,   49,   49,
			   57,   59,   63,   58,   60,   65,   86,   64,   66,   68,
			   69,   72,   70,   87,   79,  117,  220,  118,  219,   73,
			   80,   81,   71,  122,   74,   94,  123,   75,  128,   95,
			   76,  221,  129,   94,  131,  221,   52,   95,   52,   52,

			   52,   52,  218,  217,  216,  215,  214,  213,  212,  132,
			   47,   47,   47,   47,   47,   47,   47,   47,   92,  211,
			   92,  210,   92,   92,   92,   92,   93,  209,   93,   93,
			   93,   93,   93,   93,   55,   55,   55,   55,   55,   55,
			   55,   55,  208,  207,  206,  205,  204,  203,  202,  201,
			  200,  199,  198,  197,  196,  195,  194,  193,  192,  191,
			  190,  189,  188,  187,  186,  185,  184,  183,  182,  181,
			  180,  179,  178,  177,  176,  175,  174,  173,  172,  171,
			  170,  169,  168,  167,  166,  165,  164,  163,  162,  161,
			  160,  159,  158,  157,  156,  155,  154,  153,  152,  151,

			  150,  149,  148,  147,  146,  145,  144,  143,  142,  141,
			  140,  139,  138,  137,  136,  135,  134,  133,  130,  127,
			  126,  125,  124,  121,  120,  119,  116,  115,  114,  113,
			  112,  111,  110,  109,  108,  107,  106,  103,  102,  101,
			  100,   99,   98,   97,   56,   96,   50,   91,   90,   89,
			   88,   85,   84,   83,   82,   78,   77,   62,   61,   56,
			   53,   51,   50,  221,    5,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,

			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    3,    4,   19,   68,   68,   30,   19,    3,    4,
			   21,   23,   28,   21,   23,   29,   40,   28,   29,   30,
			   31,   32,   31,   40,   35,   81,  219,   81,  218,   32,
			   35,   35,   31,   85,   32,   49,   85,   32,   90,   49,
			   32,   93,   90,   94,   99,   93,  223,   94,  223,  223,

			  223,  223,  217,  216,  213,  211,  209,  208,  204,   99,
			  222,  222,  222,  222,  222,  222,  222,  222,  224,  203,
			  224,  202,  224,  224,  224,  224,  225,  201,  225,  225,
			  225,  225,  225,  225,  226,  226,  226,  226,  226,  226,
			  226,  226,  200,  199,  197,  195,  194,  193,  192,  191,
			  190,  189,  185,  184,  179,  178,  177,  176,  175,  174,
			  173,  171,  170,  169,  167,  166,  164,  161,  160,  159,
			  158,  157,  154,  153,  152,  151,  150,  149,  148,  146,
			  144,  143,  142,  141,  140,  138,  137,  135,  133,  132,
			  131,  129,  128,  126,  125,  124,  123,  122,  121,  119,

			  118,  116,  115,  114,  113,  112,  111,  110,  109,  108,
			  107,  106,  105,  104,  103,  102,  101,  100,   97,   89,
			   88,   87,   86,   84,   83,   82,   80,   78,   77,   76,
			   75,   74,   73,   72,   71,   70,   69,   67,   66,   65,
			   64,   63,   61,   60,   56,   55,   50,   45,   43,   42,
			   41,   39,   38,   37,   36,   34,   33,   25,   24,   20,
			   12,    9,    7,    5,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,

			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   48,   49,  263,  264,  260,  264,  242,
			    0,  264,  253,  264,  264,  264,  264,  264,  264,   43,
			  244,   44,  264,   45,  239,  238,  264,  264,   21,   28,
			   32,   36,   47,  219,  231,   45,  217,  219,  212,  223,
			   26,  214,  225,  217,  264,  198,  264,    0,  264,   75,
			  244,  264,    0,  264,  264,  242,  229,  264,  264,  264,
			  224,  222,  264,  200,  208,  202,  210,  203,   19,  195,
			  194,  202,  199,  196,  191,  202,  193,  186,  183,    0,
			  188,   33,  198,  197,  186,   44,  179,  183,  188,  179,
			   60,  264,    0,   81,   83,  264,  264,  198,  264,   66,

			  180,  182,  191,  180,  175,  171,  183,  167,  168,  167,
			  175,  182,  177,  178,  166,  165,  167,    0,  176,  167,
			    0,  172,  154,  153,  167,  166,  154,    0,  152,  157,
			  264,  150,  154,  153,    0,  154,    0,  152,  143,    0,
			  144,  141,  154,  139,  146,    0,  137,    0,  152,  149,
			  136,  146,  146,  141,  132,    0,    0,  128,  142,  141,
			  126,  139,    0,    0,  138,    0,  137,  123,    0,  135,
			  128,  129,    0,  125,  127,  126,  130,  116,  119,  126,
			    0,    0,    0,    0,  111,  111,    0,    0,    0,  114,
			  122,  125,  120,  104,  118,  104,    0,  116,    0,  107,

			  106,   91,   80,   79,   67,    0,    0,    0,   65,   64,
			    0,   77,    0,   80,    0,    0,   61,   70,   41,   40,
			    0,  264,  109,   93,  117,  125,  133, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,  221,    1,  222,  222,  221,  221,  221,  221,  221,
			  223,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  221,  221,  221,  224,  221,  225,
			  221,  221,  223,  221,  221,  226,  221,  221,  221,  221,
			  221,  221,  221,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  221,  224,  225,  225,  221,  221,  221,  221,  223,

			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  221,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,

			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,    0,  221,  221,  221,  221,  221, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    4,    5,    5,    5,    6,    7,    5,
			    8,    9,   10,   11,   12,   13,    5,   14,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   16,   17,
			   18,   19,   20,    5,    1,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   22,    5,   23,    5,    5,    5,   24,   25,   26,

			   27,   28,   29,   30,   31,   32,   21,   33,   34,   35,
			   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
			   46,   47,   21,   48,   49,   50,    5,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    2,    1,    3,    1,    1,    1,    1,
			    4,    1,    1,    1,    1,    5,    1,    1,    1,    1,
			    1,    6,    1,    1,    3,    3,    3,    3,    3,    3,
			    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
			    3,    3,    3,    3,    3,    3,    7,    8,    1,    1,
			    1, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    3,    3,   75,   74,    7,    8,   67,
			   72,   66,   74,   59,   60,   64,   62,   58,   63,   65,
			   73,   61,   68,   46,   69,   47,   56,   57,   72,   72,
			   72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
			   72,   72,   72,   72,   70,   74,   71,    3,    5,    4,
			    7,   45,   72,   54,    2,    0,   73,   51,   43,   50,
			   48,   44,   49,   72,   72,   72,   72,   72,   72,   72,
			   72,   72,   72,   72,   72,   72,   72,   72,   72,   27,
			   72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
			   72,   55,    3,    4,    4,    6,    1,    0,   53,   72,

			   72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
			   72,   72,   72,   72,   72,   72,   72,   29,   72,   72,
			   32,   72,   72,   72,   72,   72,   72,   40,   72,   72,
			   52,   72,   72,   72,   12,   72,   14,   72,   72,   17,
			   72,   72,   72,   72,   72,   23,   72,   25,   72,   72,
			   72,   72,   72,   72,   72,   37,   38,   72,   72,   72,
			   72,   72,   11,   13,   72,   16,   72,   72,   20,   72,
			   72,   72,   26,   72,   72,   72,   72,   72,   72,   72,
			   41,   42,    9,   10,   72,   72,   19,   21,   22,   72,
			   72,   72,   72,   72,   72,   35,   39,   72,   18,   72,

			   72,   72,   72,   72,   72,   36,   15,   24,   72,   72,
			   31,   72,   34,   72,   30,   33,   72,   72,   72,   72,
			   28,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 264
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 221
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 222
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 74
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 75
			-- End of buffer rule code

	yyLine_used: BOOLEAN is false
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	comment: INTEGER is 1
			-- Start condition codes

feature -- User-defined features



  line_nb: INTEGER
           -- Current line number

  scanned_file: PLAIN_TEXT_FILE
  scanned_file_to_string: STRING
  scanned_file_to_buffer: YY_BUFFER

  feature {NONE} -- Initialization

       make_with_given_filename (filename: STRING) is
             -- Create new scanner with
             -- filename as input file
          do
             create scanned_file.make_open_read (filename)

             from create scanned_file_to_string.make_empty
             until scanned_file.end_of_file
             loop
             	scanned_file.read_character
             	scanned_file_to_string.extend (scanned_file.last_character)
             end

 			create scanned_file_to_buffer.make (scanned_file_to_string)
			make_with_buffer (scanned_file_to_buffer)
         -- scan
         end

  end
