-- Copyright (C) 2009  Carlo A. Furia
--                     caf@inf.ethz.ch  http://se.inf.ethz.ch/people/furia/
--                     
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.


indexing

	description: "Parser token codes"
	generator: "geyacc version 3.9"

class BOOGIEPL_TERMINAL_TOKEN_CODES

inherit

	YY_PARSER_TOKENS

feature -- Last values

	last_any_value: ANY
	last_string_value: STRING

feature -- Access

	token_name (a_token: INTEGER): STRING is
			-- Name of token `a_token'
		do
			inspect a_token
			when 0 then
				Result := "EOF token"
			when -1 then
				Result := "Error token"
			when ASSERTKW then
				Result := "ASSERTKW"
			when ASSUMEKW then
				Result := "ASSUMEKW"
			when AXIOMKW then
				Result := "AXIOMKW"
			when BOOLKW then
				Result := "BOOLKW"
			when BREAKKW then
				Result := "BREAKKW"
			when CALLKW then
				Result := "CALLKW"
			when COMPLETEKW then
				Result := "COMPLETEKW"
			when CONSTKW then
				Result := "CONSTKW"
			when ELSEKW then
				Result := "ELSEKW"
			when ENSURESKW then
				Result := "ENSURESKW"
			when FALSEKW then
				Result := "FALSEKW"
			when FINITEKW then
				Result := "FINITEKW"
			when FREEKW then
				Result := "FREEKW"
			when FUNCTIONKW then
				Result := "FUNCTIONKW"
			when GOTOKW then
				Result := "GOTOKW"
			when HAVOCKW then
				Result := "HAVOCKW"
			when IFKW then
				Result := "IFKW"
			when IMPLEMENTATIONKW then
				Result := "IMPLEMENTATIONKW"
			when INTKW then
				Result := "INTKW"
			when INVARIANTKW then
				Result := "INVARIANTKW"
			when MODIFIESKW then
				Result := "MODIFIESKW"
			when OLDKW then
				Result := "OLDKW"
			when PROCEDUREKW then
				Result := "PROCEDUREKW"
			when REQUIRESKW then
				Result := "REQUIRESKW"
			when RETURNKW then
				Result := "RETURNKW"
			when RETURNSKW then
				Result := "RETURNSKW"
			when TRUEKW then
				Result := "TRUEKW"
			when TYPEKW then
				Result := "TYPEKW"
			when UNIQUEKW then
				Result := "UNIQUEKW"
			when VARKW then
				Result := "VARKW"
			when WHEREKW then
				Result := "WHEREKW"
			when WHILEKW then
				Result := "WHILEKW"
			when ASSIGNEMENTKW then
				Result := "ASSIGNEMENTKW"
			when OPENBRACKETKW then
				Result := "OPENBRACKETKW"
			when CLOSEDBRACKETKW then
				Result := "CLOSEDBRACKETKW"
			when COMMAKW then
				Result := "COMMAKW"
			when OPENPARENKW then
				Result := "OPENPARENKW"
			when CLOSEDPARENKW then
				Result := "CLOSEDPARENKW"
			when COLONKW then
				Result := "COLONKW"
			when SEMICOLONKW then
				Result := "SEMICOLONKW"
			when EQUALSIGNKW then
				Result := "EQUALSIGNKW"
			when CURLYOPENKW then
				Result := "CURLYOPENKW"
			when CURLYCLOSEDKW then
				Result := "CURLYCLOSEDKW"
			when IDID then
				Result := "IDID"
			when NUM then
				Result := "NUM"
			when DOUBLECOLONKW then
				Result := "DOUBLECOLONKW"
			when IFFKW then
				Result := "IFFKW"
			when FORALLKW then
				Result := "FORALLKW"
			when EXISTSKW then
				Result := "EXISTSKW"
			when IMPLIESKW then
				Result := "IMPLIESKW"
			when ANDKW then
				Result := "ANDKW"
			when ORKW then
				Result := "ORKW"
			when EQUALKW then
				Result := "EQUALKW"
			when NEQUALKW then
				Result := "NEQUALKW"
			when LESSTHANKW then
				Result := "LESSTHANKW"
			when GREATERTHANKW then
				Result := "GREATERTHANKW"
			when LESSTHANOREQUALTOKW then
				Result := "LESSTHANOREQUALTOKW"
			when GREATERTHANOREQUALTOKW then
				Result := "GREATERTHANOREQUALTOKW"
			when PRECEDESKW then
				Result := "PRECEDESKW"
			when PLUSKW then
				Result := "PLUSKW"
			when MINUSKW then
				Result := "MINUSKW"
			when TIMESKW then
				Result := "TIMESKW"
			when DIVIDEKW then
				Result := "DIVIDEKW"
			when PERCENTKW then
				Result := "PERCENTKW"
			when UMINUSNEGKW then
				Result := "UMINUSNEGKW"
			when BANGKW then
				Result := "BANGKW"
			else
				Result := yy_character_token_name (a_token)
			end
		end

feature -- Token codes

	ASSERTKW: INTEGER is 258
	ASSUMEKW: INTEGER is 259
	AXIOMKW: INTEGER is 260
	BOOLKW: INTEGER is 261
	BREAKKW: INTEGER is 262
	CALLKW: INTEGER is 263
	COMPLETEKW: INTEGER is 264
	CONSTKW: INTEGER is 265
	ELSEKW: INTEGER is 266
	ENSURESKW: INTEGER is 267
	FALSEKW: INTEGER is 268
	FINITEKW: INTEGER is 269
	FREEKW: INTEGER is 270
	FUNCTIONKW: INTEGER is 271
	GOTOKW: INTEGER is 272
	HAVOCKW: INTEGER is 273
	IFKW: INTEGER is 274
	IMPLEMENTATIONKW: INTEGER is 275
	INTKW: INTEGER is 276
	INVARIANTKW: INTEGER is 277
	MODIFIESKW: INTEGER is 278
	OLDKW: INTEGER is 279
	PROCEDUREKW: INTEGER is 280
	REQUIRESKW: INTEGER is 281
	RETURNKW: INTEGER is 282
	RETURNSKW: INTEGER is 283
	TRUEKW: INTEGER is 284
	TYPEKW: INTEGER is 285
	UNIQUEKW: INTEGER is 286
	VARKW: INTEGER is 287
	WHEREKW: INTEGER is 288
	WHILEKW: INTEGER is 289
	ASSIGNEMENTKW: INTEGER is 290
	OPENBRACKETKW: INTEGER is 291
	CLOSEDBRACKETKW: INTEGER is 292
	COMMAKW: INTEGER is 293
	OPENPARENKW: INTEGER is 294
	CLOSEDPARENKW: INTEGER is 295
	COLONKW: INTEGER is 296
	SEMICOLONKW: INTEGER is 297
	EQUALSIGNKW: INTEGER is 298
	CURLYOPENKW: INTEGER is 299
	CURLYCLOSEDKW: INTEGER is 300
	IDID: INTEGER is 301
	NUM: INTEGER is 302
	DOUBLECOLONKW: INTEGER is 303
	IFFKW: INTEGER is 304
	FORALLKW: INTEGER is 305
	EXISTSKW: INTEGER is 306
	IMPLIESKW: INTEGER is 307
	ANDKW: INTEGER is 308
	ORKW: INTEGER is 309
	EQUALKW: INTEGER is 310
	NEQUALKW: INTEGER is 311
	LESSTHANKW: INTEGER is 312
	GREATERTHANKW: INTEGER is 313
	LESSTHANOREQUALTOKW: INTEGER is 314
	GREATERTHANOREQUALTOKW: INTEGER is 315
	PRECEDESKW: INTEGER is 316
	PLUSKW: INTEGER is 317
	MINUSKW: INTEGER is 318
	TIMESKW: INTEGER is 319
	DIVIDEKW: INTEGER is 320
	PERCENTKW: INTEGER is 321
	UMINUSNEGKW: INTEGER is 322
	BANGKW: INTEGER is 323

end
