-- Copyright (C) 2009  Carlo A. Furia
--                     caf@inf.ethz.ch  http://se.inf.ethz.ch/people/furia/
--                     
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.


class BOOGIEPL_TOKEN_CODES


inherit BOOGIEPL_TERMINAL_TOKEN_CODES
	 redefine token_name end

 feature  -- Access 

	 token_name (a_token: INTEGER): STRING is 
	 do 
		 if not Precursor (a_token).is_equal("Unknown token") then Result := Precursor (a_token)
		else
		 inspect a_token 
		 when 0 then Result := "EOF token" 
		 when -1 then Result := "Error token" 
		 else 
		 if a_token = input then Result := "input" else 
		 if a_token = Program then Result := "Program" else 
		 if a_token = Decl then Result := "Decl" else 
		 if a_token = Expr then Result := "Expr" else 
		 if a_token = E0 then Result := "E0" else 
		 if a_token = E1 then Result := "E1" else 
		 if a_token = E2 then Result := "E2" else 
		 if a_token = EOrplus then Result := "EOrplus" else 
		 if a_token = EOr then Result := "EOr" else 
		 if a_token = EAndplus then Result := "EAndplus" else 
		 if a_token = EAnd then Result := "EAnd" else 
		 if a_token = OrOp then Result := "OrOp" else 
		 if a_token = AndOp then Result := "AndOp" else 
		 if a_token = E3 then Result := "E3" else 
		 if a_token = E4 then Result := "E4" else 
		 if a_token = E5 then Result := "E5" else 
		 if a_token = E6 then Result := "E6" else 
		 if a_token = E7 then Result := "E7" else 
		 if a_token = E8 then Result := "E8" else 
		 if a_token = MapOpstar then Result := "MapOpstar" else 
		 if a_token = MapOp then Result := "MapOp" else 
		 if a_token = Exprpluscomma then Result := "Exprpluscomma" else 
		 if a_token = Exprstarcomma then Result := "Exprstarcomma" else 
		 if a_token = MapUpdate then Result := "MapUpdate" else 
		 if a_token = Number then Result := "Number" else 
		 if a_token = E9 then Result := "E9" else 
		 if a_token = IdsTypepluscomma then Result := "IdsTypepluscomma" else 
		 if a_token = FuncApplication then Result := "FuncApplication" else 
		 if a_token = Id then Result := "Id" else 
		 if a_token = Idpluscomma then Result := "Idpluscomma" else 
		 if a_token = TypeArgs then Result := "TypeArgs" else 
		 if a_token = IdsType then Result := "IdsType" else 
		 if a_token = UnOpstar then Result := "UnOpstar" else 
		 if a_token = AddOp then Result := "AddOp" else 
		 if a_token = MulOp then Result := "MulOp" else 
		 if a_token = UnOp then Result := "UnOp" else 
		 if a_token = EquivOp then Result := "EquivOp" else 
		 if a_token = ImplOp then Result := "ImplOp" else 
		 if a_token = RelOp then Result := "RelOp" else 
		 if a_token = QOp then Result := "QOp" else 
		 if a_token = QSep then Result := "QSep" else 
		 if a_token = TypeDecl then Result := "TypeDecl" else 
		 if a_token = TypeConstructor then Result := "TypeConstructor" else 
		 if a_token = Idplus then Result := "Idplus" else 
		 if a_token = TypeK then Result := "TypeK" else 
		 if a_token = TypeAtom then Result := "TypeAtom" else 
		 if a_token = MapType then Result := "MapType" else 
		 if a_token = Typepluscomma then Result := "Typepluscomma" else 
		 if a_token = TypeCtorArgs then Result := "TypeCtorArgs" else 
		 if a_token = TypeSynonym then Result := "TypeSynonym" else 
		 if a_token = ConstantDecl then Result := "ConstantDecl" else 
		 if a_token = FunctionDecl then Result := "FunctionDecl" else 
		 if a_token = FSig then Result := "FSig" else 
		 if a_token = Fargstarcomma then Result := "Fargstarcomma" else 
		 if a_token = Fargpluscomma then Result := "Fargpluscomma" else 
		 if a_token = FArg then Result := "FArg" else 
		 if a_token = FArgName then Result := "FArgName" else 
		 if a_token = AxiomDecl then Result := "AxiomDecl" else 
		 if a_token = VarDecl then Result := "VarDecl" else 
		 if a_token = IdsTypeWherepluscomma then Result := "IdsTypeWherepluscomma" else 
		 if a_token = IdsTypeWherestarcomma then Result := "IdsTypeWherestarcomma" else 
		 if a_token = IdsTypeWhere then Result := "IdsTypeWhere" else 
		 if a_token = WhereClause then Result := "WhereClause" else 
		 if a_token = ProcedureDecl then Result := "ProcedureDecl" else 
		 if a_token = Specstar then Result := "Specstar" else 
		 if a_token = Bodystar then Result := "Bodystar" else 
		 if a_token = PSig then Result := "PSig" else 
		 if a_token = OutParameters then Result := "OutParameters" else 
		 if a_token = Spec then Result := "Spec" else 
		 if a_token = Idstarcomma then Result := "Idstarcomma" else 
		 if a_token = ImplementationDecl then Result := "ImplementationDecl" else 
		 if a_token = ISig then Result := "ISig" else 
		 if a_token = OutParams then Result := "OutParams" else 
		 if a_token = IdsTypestarcomma then Result := "IdsTypestarcomma" else 
		 if a_token = Body then Result := "Body" else 
		 if a_token = LocalVarDeclstar then Result := "LocalVarDeclstar" else 
		 if a_token = LocalVarDecl then Result := "LocalVarDecl" else 
		 if a_token = StmtList then Result := "StmtList" else 
		 if a_token = LStmtstar then Result := "LStmtstar" else 
		 if a_token = LStmt then Result := "LStmt" else 
		 if a_token = LEmpty then Result := "LEmpty" else 
		 if a_token = Stmt then Result := "Stmt" else 
		 if a_token = Lhspluscomma then Result := "Lhspluscomma" else 
		 if a_token = Lhs then Result := "Lhs" else 
		 if a_token = MapSelectstar then Result := "MapSelectstar" else 
		 if a_token = MapSelect then Result := "MapSelect" else 
		 if a_token = CallLhs then Result := "CallLhs" else 
		 if a_token = WildcardExprstarcomma then Result := "WildcardExprstarcomma" else 
		 if a_token = WildcardExprpluscomma then Result := "WildcardExprpluscomma" else 
		 if a_token = WildcardExpr then Result := "WildcardExpr" else 
		 if a_token = BlockStmt then Result := "BlockStmt" else 
		 if a_token = IfStmt then Result := "IfStmt" else 
		 if a_token = Elsepart then Result := "Elsepart" else 
		 if a_token = LoopInvstar then Result := "LoopInvstar" else 
		 if a_token = LoopInv then Result := "LoopInv" else 
		 if a_token = OrderSpec then Result := "OrderSpec" else 
		 if a_token = ParentInfo then Result := "ParentInfo" else 
		 if a_token = ParentEdgestarcomma then Result := "ParentEdgestarcomma" else 
		 if a_token = ParentEdgepluscomma then Result := "ParentEdgepluscomma" else 
		 if a_token = ParentEdge then Result := "ParentEdge" else 
		 Result := "Unknown token"
 		 end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end end
		 end 
		end 
	end 
		

	 top_terminal_token: INTEGER is 
		 once 
		 Result := 0 
		 if ASSERTKW > Result then Result := ASSERTKW end 
		 if ASSUMEKW > Result then Result := ASSUMEKW end 
		 if AXIOMKW > Result then Result := AXIOMKW end 
		 if BOOLKW > Result then Result := BOOLKW end 
		 if BREAKKW > Result then Result := BREAKKW end 
		 if CALLKW > Result then Result := CALLKW end 
		 if COMPLETEKW > Result then Result := COMPLETEKW end 
		 if CONSTKW > Result then Result := CONSTKW end 
		 if ELSEKW > Result then Result := ELSEKW end 
		 if ENSURESKW > Result then Result := ENSURESKW end 
		 if FALSEKW > Result then Result := FALSEKW end 
		 if FINITEKW > Result then Result := FINITEKW end 
		 if FREEKW > Result then Result := FREEKW end 
		 if FUNCTIONKW > Result then Result := FUNCTIONKW end 
		 if GOTOKW > Result then Result := GOTOKW end 
		 if HAVOCKW > Result then Result := HAVOCKW end 
		 if IFKW > Result then Result := IFKW end 
		 if IMPLEMENTATIONKW > Result then Result := IMPLEMENTATIONKW end 
		 if INTKW > Result then Result := INTKW end 
		 if INVARIANTKW > Result then Result := INVARIANTKW end 
		 if MODIFIESKW > Result then Result := MODIFIESKW end 
		 if OLDKW > Result then Result := OLDKW end 
		 if PROCEDUREKW > Result then Result := PROCEDUREKW end 
		 if REQUIRESKW > Result then Result := REQUIRESKW end 
		 if RETURNKW > Result then Result := RETURNKW end 
		 if RETURNSKW > Result then Result := RETURNSKW end 
		 if TRUEKW > Result then Result := TRUEKW end 
		 if TYPEKW > Result then Result := TYPEKW end 
		 if UNIQUEKW > Result then Result := UNIQUEKW end 
		 if VARKW > Result then Result := VARKW end 
		 if WHEREKW > Result then Result := WHEREKW end 
		 if WHILEKW > Result then Result := WHILEKW end 
		 if ASSIGNEMENTKW > Result then Result := ASSIGNEMENTKW end 
		 if ASSIGNEMENTKW > Result then Result := ASSIGNEMENTKW end 
		 if OPENBRACKETKW > Result then Result := OPENBRACKETKW end 
		 if CLOSEDBRACKETKW > Result then Result := CLOSEDBRACKETKW end 
		 if COMMAKW > Result then Result := COMMAKW end 
		 if OPENPARENKW > Result then Result := OPENPARENKW end 
		 if CLOSEDPARENKW > Result then Result := CLOSEDPARENKW end 
		 if COLONKW > Result then Result := COLONKW end 
		 if SEMICOLONKW > Result then Result := SEMICOLONKW end 
		 if EQUALSIGNKW > Result then Result := EQUALSIGNKW end 
		 if CURLYOPENKW > Result then Result := CURLYOPENKW end 
		 if CURLYCLOSEDKW > Result then Result := CURLYCLOSEDKW end 
		 if IDID > Result then Result := IDID end 
		 if NUM > Result then Result := NUM end 
		 if DOUBLECOLONKW > Result then Result := DOUBLECOLONKW end 
		 if IFFKW > Result then Result := IFFKW end 
		 if FORALLKW > Result then Result := FORALLKW end 
		 if EXISTSKW > Result then Result := EXISTSKW end 
		 if IMPLIESKW > Result then Result := IMPLIESKW end 
		 if ANDKW > Result then Result := ANDKW end 
		 if ORKW > Result then Result := ORKW end 
		 if EQUALKW > Result then Result := EQUALKW end 
		 if NEQUALKW > Result then Result := NEQUALKW end 
		 if LESSTHANKW > Result then Result := LESSTHANKW end 
		 if GREATERTHANKW > Result then Result := GREATERTHANKW end 
		 if LESSTHANOREQUALTOKW > Result then Result := LESSTHANOREQUALTOKW end 
		 if GREATERTHANOREQUALTOKW > Result then Result := GREATERTHANOREQUALTOKW end 
		 if PRECEDESKW > Result then Result := PRECEDESKW end 
		 if PLUSKW > Result then Result := PLUSKW end 
		 if MINUSKW > Result then Result := MINUSKW end 
		 if TIMESKW > Result then Result := TIMESKW end 
		 if DIVIDEKW > Result then Result := DIVIDEKW end 
		 if PERCENTKW > Result then Result := PERCENTKW end 
		 if UMINUSNEGKW > Result then Result := UMINUSNEGKW end 
		 if BANGKW > Result then Result := BANGKW end 
		 if IFFKW > Result then Result := IFFKW end 
		 if FORALLKW > Result then Result := FORALLKW end 
		 if EXISTSKW > Result then Result := EXISTSKW end 
		 if IMPLIESKW > Result then Result := IMPLIESKW end 
		 if ANDKW > Result then Result := ANDKW end 
		 if ORKW > Result then Result := ORKW end 
		 if EQUALKW > Result then Result := EQUALKW end 
		 if NEQUALKW > Result then Result := NEQUALKW end 
		 if LESSTHANKW > Result then Result := LESSTHANKW end 
		 if GREATERTHANKW > Result then Result := GREATERTHANKW end 
		 if LESSTHANOREQUALTOKW > Result then Result := LESSTHANOREQUALTOKW end 
		 if GREATERTHANOREQUALTOKW > Result then Result := GREATERTHANOREQUALTOKW end 
		 if PRECEDESKW > Result then Result := PRECEDESKW end 
		 if PLUSKW > Result then Result := PLUSKW end 
		 if MINUSKW > Result then Result := MINUSKW end 
		 if TIMESKW > Result then Result := TIMESKW end 
		 if DIVIDEKW > Result then Result := DIVIDEKW end 
		 if PERCENTKW > Result then Result := PERCENTKW end 
		 if UMINUSNEGKW > Result then Result := UMINUSNEGKW end 
		 if BANGKW > Result then Result := BANGKW end 
		 end 

feature -- Nonterminal token codes 

	input: INTEGER do Result := 2 + top_terminal_token end
	Program: INTEGER do Result := 3 + top_terminal_token end
	Decl: INTEGER do Result := 4 + top_terminal_token end
	Expr: INTEGER do Result := 5 + top_terminal_token end
	E0: INTEGER do Result := 6 + top_terminal_token end
	E1: INTEGER do Result := 7 + top_terminal_token end
	E2: INTEGER do Result := 8 + top_terminal_token end
	EOrplus: INTEGER do Result := 9 + top_terminal_token end
	EOr: INTEGER do Result := 10 + top_terminal_token end
	EAndplus: INTEGER do Result := 11 + top_terminal_token end
	EAnd: INTEGER do Result := 12 + top_terminal_token end
	OrOp: INTEGER do Result := 13 + top_terminal_token end
	AndOp: INTEGER do Result := 14 + top_terminal_token end
	E3: INTEGER do Result := 15 + top_terminal_token end
	E4: INTEGER do Result := 16 + top_terminal_token end
	E5: INTEGER do Result := 17 + top_terminal_token end
	E6: INTEGER do Result := 18 + top_terminal_token end
	E7: INTEGER do Result := 19 + top_terminal_token end
	E8: INTEGER do Result := 20 + top_terminal_token end
	MapOpstar: INTEGER do Result := 21 + top_terminal_token end
	MapOp: INTEGER do Result := 22 + top_terminal_token end
	Exprpluscomma: INTEGER do Result := 23 + top_terminal_token end
	Exprstarcomma: INTEGER do Result := 24 + top_terminal_token end
	MapUpdate: INTEGER do Result := 25 + top_terminal_token end
	Number: INTEGER do Result := 26 + top_terminal_token end
	E9: INTEGER do Result := 27 + top_terminal_token end
	IdsTypepluscomma: INTEGER do Result := 28 + top_terminal_token end
	FuncApplication: INTEGER do Result := 29 + top_terminal_token end
	Id: INTEGER do Result := 30 + top_terminal_token end
	Idpluscomma: INTEGER do Result := 31 + top_terminal_token end
	TypeArgs: INTEGER do Result := 32 + top_terminal_token end
	IdsType: INTEGER do Result := 33 + top_terminal_token end
	UnOpstar: INTEGER do Result := 34 + top_terminal_token end
	AddOp: INTEGER do Result := 35 + top_terminal_token end
	MulOp: INTEGER do Result := 36 + top_terminal_token end
	UnOp: INTEGER do Result := 37 + top_terminal_token end
	EquivOp: INTEGER do Result := 38 + top_terminal_token end
	ImplOp: INTEGER do Result := 39 + top_terminal_token end
	RelOp: INTEGER do Result := 40 + top_terminal_token end
	QOp: INTEGER do Result := 41 + top_terminal_token end
	QSep: INTEGER do Result := 42 + top_terminal_token end
	TypeDecl: INTEGER do Result := 43 + top_terminal_token end
	TypeConstructor: INTEGER do Result := 44 + top_terminal_token end
	Idplus: INTEGER do Result := 45 + top_terminal_token end
	TypeK: INTEGER do Result := 46 + top_terminal_token end
	TypeAtom: INTEGER do Result := 47 + top_terminal_token end
	MapType: INTEGER do Result := 48 + top_terminal_token end
	Typepluscomma: INTEGER do Result := 49 + top_terminal_token end
	TypeCtorArgs: INTEGER do Result := 50 + top_terminal_token end
	TypeSynonym: INTEGER do Result := 51 + top_terminal_token end
	ConstantDecl: INTEGER do Result := 52 + top_terminal_token end
	FunctionDecl: INTEGER do Result := 53 + top_terminal_token end
	FSig: INTEGER do Result := 54 + top_terminal_token end
	Fargstarcomma: INTEGER do Result := 55 + top_terminal_token end
	Fargpluscomma: INTEGER do Result := 56 + top_terminal_token end
	FArg: INTEGER do Result := 57 + top_terminal_token end
	FArgName: INTEGER do Result := 58 + top_terminal_token end
	AxiomDecl: INTEGER do Result := 59 + top_terminal_token end
	VarDecl: INTEGER do Result := 60 + top_terminal_token end
	IdsTypeWherepluscomma: INTEGER do Result := 61 + top_terminal_token end
	IdsTypeWherestarcomma: INTEGER do Result := 62 + top_terminal_token end
	IdsTypeWhere: INTEGER do Result := 63 + top_terminal_token end
	WhereClause: INTEGER do Result := 64 + top_terminal_token end
	ProcedureDecl: INTEGER do Result := 65 + top_terminal_token end
	Specstar: INTEGER do Result := 66 + top_terminal_token end
	Bodystar: INTEGER do Result := 67 + top_terminal_token end
	PSig: INTEGER do Result := 68 + top_terminal_token end
	OutParameters: INTEGER do Result := 69 + top_terminal_token end
	Spec: INTEGER do Result := 70 + top_terminal_token end
	Idstarcomma: INTEGER do Result := 71 + top_terminal_token end
	ImplementationDecl: INTEGER do Result := 72 + top_terminal_token end
	ISig: INTEGER do Result := 73 + top_terminal_token end
	OutParams: INTEGER do Result := 74 + top_terminal_token end
	IdsTypestarcomma: INTEGER do Result := 75 + top_terminal_token end
	Body: INTEGER do Result := 76 + top_terminal_token end
	LocalVarDeclstar: INTEGER do Result := 77 + top_terminal_token end
	LocalVarDecl: INTEGER do Result := 78 + top_terminal_token end
	StmtList: INTEGER do Result := 79 + top_terminal_token end
	LStmtstar: INTEGER do Result := 80 + top_terminal_token end
	LStmt: INTEGER do Result := 81 + top_terminal_token end
	LEmpty: INTEGER do Result := 82 + top_terminal_token end
	Stmt: INTEGER do Result := 83 + top_terminal_token end
	Lhspluscomma: INTEGER do Result := 84 + top_terminal_token end
	Lhs: INTEGER do Result := 85 + top_terminal_token end
	MapSelectstar: INTEGER do Result := 86 + top_terminal_token end
	MapSelect: INTEGER do Result := 87 + top_terminal_token end
	CallLhs: INTEGER do Result := 88 + top_terminal_token end
	WildcardExprstarcomma: INTEGER do Result := 89 + top_terminal_token end
	WildcardExprpluscomma: INTEGER do Result := 90 + top_terminal_token end
	WildcardExpr: INTEGER do Result := 91 + top_terminal_token end
	BlockStmt: INTEGER do Result := 92 + top_terminal_token end
	IfStmt: INTEGER do Result := 93 + top_terminal_token end
	Elsepart: INTEGER do Result := 94 + top_terminal_token end
	LoopInvstar: INTEGER do Result := 95 + top_terminal_token end
	LoopInv: INTEGER do Result := 96 + top_terminal_token end
	OrderSpec: INTEGER do Result := 97 + top_terminal_token end
	ParentInfo: INTEGER do Result := 98 + top_terminal_token end
	ParentEdgestarcomma: INTEGER do Result := 99 + top_terminal_token end
	ParentEdgepluscomma: INTEGER do Result := 100 + top_terminal_token end
	ParentEdge: INTEGER do Result := 101 + top_terminal_token end

end
