-- Copyright (C) 2009  Carlo A. Furia
--                     caf@inf.ethz.ch  http://se.inf.ethz.ch/people/furia/
--                     
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.


indexing

  description: "Parser for Boogie v. 2"

class BOOGIEPL_PARSER

inherit

	  YY_PARSER_SKELETON
	    rename
	      make as make_parser_skeleton
       redefine
	      report_error
       end

	  BOOGIEPL_SCANNER
	     rename
	       make as make_std_scanner,
          make_with_given_filename as make_scanner
	     export
	       {NONE} all
		  end

create

	  make


feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks is
			-- Create value stacks.
		do
		end

	yy_init_value_stacks is
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
		end

	yy_clear_value_stacks is
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			if yyvs1 /= Void then
				yyvs1.clear_all
			end
			if yyvs2 /= Void then
				yyvs2.clear_all
			end
			if yyvs3 /= Void then
				yyvs3.clear_all
			end
		end

	yy_push_last_value (yychar1: INTEGER) is
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					if yyvs1 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs1")
						end
						create yyspecial_routines1
						yyvsc1 := yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.make (yyvsc1)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs1")
						end
						yyvsc1 := yyvsc1 + yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
					end
				end
				yyvs1.put (last_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					if yyvs2 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs2")
						end
						create yyspecial_routines2
						yyvsc2 := yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.make (yyvsc2)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs2")
						end
						yyvsc2 := yyvsc2 + yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
					end
				end
				yyvs2.put (last_string_value, yyvsp2)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value is
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				if yyvs1 = Void then
					debug ("GEYACC")
						std.error.put_line ("Create yyvs1")
					end
					create yyspecial_routines1
					yyvsc1 := yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.make (yyvsc1)
				else
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
				end
			end
			yyvs1.put (yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER) is
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval3: PRODUCTION_CLASS
		do
			inspect yy_act
when 1 then
--|#line 95 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 95")
end

create yyval3.make (input); yyval3.add_child (yyvs3.item (yyvsp3)); parse_tree := yyval3; 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 2 then
--|#line 100 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 100")
end

create yyval3.make (Program); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 3 then
--|#line 102 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 102")
end

create yyval3.make (Program); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 4 then
--|#line 107 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 107")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 5 then
--|#line 109 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 109")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 6 then
--|#line 111 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 111")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 7 then
--|#line 113 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 113")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 8 then
--|#line 115 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 115")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 9 then
--|#line 117 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 117")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 10 then
--|#line 119 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 119")
end

create yyval3.make (Decl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 11 then
--|#line 124 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 124")
end

create yyval3.make (Expr); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 12 then
--|#line 129 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 129")
end

create yyval3.make (E0); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 13 then
--|#line 131 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 131")
end

create yyval3.make (E0); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 14 then
--|#line 136 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 136")
end

create yyval3.make (E1); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 15 then
--|#line 138 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 138")
end

create yyval3.make (E1); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 16 then
--|#line 143 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 143")
end

create yyval3.make (E2); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 17 then
--|#line 145 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 145")
end

create yyval3.make (E2); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 18 then
--|#line 147 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 147")
end

create yyval3.make (E2); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 19 then
--|#line 152 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 152")
end

create yyval3.make (EOrplus); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 20 then
--|#line 154 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 154")
end

create yyval3.make (EOrplus); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 21 then
--|#line 159 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 159")
end

create yyval3.make (EOr); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 22 then
--|#line 164 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 164")
end

create yyval3.make (EAndplus); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 23 then
--|#line 166 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 166")
end

create yyval3.make (EAndplus); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 24 then
--|#line 171 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 171")
end

create yyval3.make (EAnd); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 25 then
--|#line 176 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 176")
end

create yyval3.make (OrOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ORKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 26 then
--|#line 181 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 181")
end

create yyval3.make (AndOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ANDKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 27 then
--|#line 186 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 186")
end

create yyval3.make (E3); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 28 then
--|#line 188 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 188")
end

create yyval3.make (E3); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 29 then
--|#line 193 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 193")
end

create yyval3.make (E4); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 30 then
--|#line 198 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 198")
end

create yyval3.make (E5); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 31 then
--|#line 200 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 200")
end

create yyval3.make (E5); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 32 then
--|#line 205 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 205")
end

create yyval3.make (E6); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 33 then
--|#line 207 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 207")
end

create yyval3.make (E6); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 34 then
--|#line 212 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 212")
end

create yyval3.make (E7); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 35 then
--|#line 217 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 217")
end

create yyval3.make (E8); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 36 then
--|#line 222 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 222")
end

create yyval3.make (MapOpstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 37 then
--|#line 224 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 224")
end

create yyval3.make (MapOpstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 38 then
--|#line 229 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 229")
end

create yyval3.make (MapOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENBRACKETKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDBRACKETKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 39 then
--|#line 231 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 231")
end

create yyval3.make (MapOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENBRACKETKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDBRACKETKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 40 then
--|#line 236 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 236")
end

create yyval3.make (Exprpluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 41 then
--|#line 238 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 238")
end

create yyval3.make (Exprpluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 42 then
--|#line 243 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 243")
end

create yyval3.make (Exprstarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 43 then
--|#line 245 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 245")
end

create yyval3.make (Exprstarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 44 then
--|#line 250 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 250")
end

create yyval3.make (MapUpdate); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ASSIGNEMENTKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 45 then
--|#line 255 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 255")
end

create yyval3.make (Number); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(NUM, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 46 then
--|#line 260 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 260")
end

create yyval3.make (E9); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FALSEKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 47 then
--|#line 262 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 262")
end

create yyval3.make (E9); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(TRUEKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 48 then
--|#line 264 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 264")
end

create yyval3.make (E9); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 49 then
--|#line 266 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 266")
end

create yyval3.make (E9); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 50 then
--|#line 268 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 268")
end

create yyval3.make (E9); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 51 then
--|#line 270 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 270")
end

create yyval3.make (E9); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OLDKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 52 then
--|#line 272 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 272")
end

create yyval3.make (E9); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 3)); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 53 then
--|#line 274 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 274")
end

create yyval3.make (E9); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 4)); yyval3.add_child (yyvs3.item (yyvsp3 - 3)); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -4
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 54 then
--|#line 276 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 276")
end

create yyval3.make (E9); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 55 then
--|#line 281 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 281")
end

create yyval3.make (IdsTypepluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 56 then
--|#line 283 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 283")
end

create yyval3.make (IdsTypepluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 57 then
--|#line 288 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 288")
end

create yyval3.make (FuncApplication); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 58 then
--|#line 293 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 293")
end

create yyval3.make (Id); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(IDID, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 59 then
--|#line 298 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 298")
end

create yyval3.make (Idpluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 60 then
--|#line 300 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 300")
end

create yyval3.make (Idpluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 61 then
--|#line 305 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 305")
end

create yyval3.make (TypeArgs); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(LESSTHANKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(GREATERTHANKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 62 then
--|#line 310 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 310")
end

create yyval3.make (IdsType); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COLONKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 63 then
--|#line 315 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 315")
end

create yyval3.make (UnOpstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 64 then
--|#line 317 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 317")
end

create yyval3.make (UnOpstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 65 then
--|#line 322 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 322")
end

create yyval3.make (AddOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(PLUSKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 66 then
--|#line 324 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 324")
end

create yyval3.make (AddOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(MINUSKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 67 then
--|#line 329 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 329")
end

create yyval3.make (MulOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(TIMESKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 68 then
--|#line 331 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 331")
end

create yyval3.make (MulOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(DIVIDEKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 69 then
--|#line 333 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 333")
end

create yyval3.make (MulOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(PERCENTKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 70 then
--|#line 338 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 338")
end

create yyval3.make (UnOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(BANGKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 71 then
--|#line 340 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 340")
end

create yyval3.make (UnOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(MINUSKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 72 then
--|#line 345 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 345")
end

create yyval3.make (EquivOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(IFFKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 73 then
--|#line 350 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 350")
end

create yyval3.make (ImplOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(IMPLIESKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 74 then
--|#line 355 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 355")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(EQUALKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 75 then
--|#line 357 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 357")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(NEQUALKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 76 then
--|#line 359 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 359")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(LESSTHANKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 77 then
--|#line 361 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 361")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(GREATERTHANKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 78 then
--|#line 363 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 363")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(LESSTHANOREQUALTOKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 79 then
--|#line 365 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 365")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(GREATERTHANOREQUALTOKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 80 then
--|#line 367 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 367")
end

create yyval3.make (RelOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(PRECEDESKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 81 then
--|#line 372 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 372")
end

create yyval3.make (QOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FORALLKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 82 then
--|#line 374 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 374")
end

create yyval3.make (QOp); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(EXISTSKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 83 then
--|#line 379 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 379")
end

create yyval3.make (QSep); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(DOUBLECOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 84 then
--|#line 384 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 384")
end

create yyval3.make (TypeDecl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 85 then
--|#line 386 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 386")
end

create yyval3.make (TypeDecl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 86 then
--|#line 391 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 391")
end

create yyval3.make (TypeConstructor); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(TYPEKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 87 then
--|#line 393 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 393")
end

create yyval3.make (TypeConstructor); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(TYPEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FINITEKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 88 then
--|#line 398 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 398")
end

create yyval3.make (Idplus); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 89 then
--|#line 400 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 400")
end

create yyval3.make (Idplus); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 90 then
--|#line 405 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 405")
end

create yyval3.make (TypeK); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 91 then
--|#line 407 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 407")
end

create yyval3.make (TypeK); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 92 then
--|#line 409 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 409")
end

create yyval3.make (TypeK); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 93 then
--|#line 411 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 411")
end

create yyval3.make (TypeK); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 94 then
--|#line 416 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 416")
end

create yyval3.make (TypeAtom); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(BOOLKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 95 then
--|#line 418 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 418")
end

create yyval3.make (TypeAtom); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(INTKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 96 then
--|#line 420 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 420")
end

create yyval3.make (TypeAtom); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 97 then
--|#line 425 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 425")
end

create yyval3.make (MapType); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENBRACKETKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDBRACKETKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 98 then
--|#line 427 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 427")
end

create yyval3.make (MapType); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENBRACKETKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDBRACKETKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 99 then
--|#line 432 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 432")
end

create yyval3.make (Typepluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 100 then
--|#line 434 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 434")
end

create yyval3.make (Typepluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 101 then
--|#line 439 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 439")
end

create yyval3.make (TypeCtorArgs); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 102 then
--|#line 441 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 441")
end

create yyval3.make (TypeCtorArgs); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 103 then
--|#line 443 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 443")
end

create yyval3.make (TypeCtorArgs); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 104 then
--|#line 445 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 445")
end

create yyval3.make (TypeCtorArgs); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 105 then
--|#line 447 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 447")
end

create yyval3.make (TypeCtorArgs); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 106 then
--|#line 452 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 452")
end

create yyval3.make (TypeSynonym); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(TYPEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(EQUALSIGNKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 107 then
--|#line 457 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 457")
end

create yyval3.make (ConstantDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CONSTKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 108 then
--|#line 459 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 459")
end

create yyval3.make (ConstantDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CONSTKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(UNIQUEKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 109 then
--|#line 464 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 464")
end

create yyval3.make (FunctionDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FUNCTIONKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 110 then
--|#line 466 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 466")
end

create yyval3.make (FunctionDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FUNCTIONKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CURLYOPENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CURLYCLOSEDKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 111 then
--|#line 471 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 471")
end

create yyval3.make (FSig); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 4))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2 - 3))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(RETURNSKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -5
	yyvs3.put (yyval3, yyvsp3)
end
when 112 then
--|#line 473 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 473")
end

create yyval3.make (FSig); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 4))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2 - 3))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(RETURNSKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -5
	yyvs3.put (yyval3, yyvsp3)
end
when 113 then
--|#line 478 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 478")
end

create yyval3.make (Fargstarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 114 then
--|#line 480 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 480")
end

create yyval3.make (Fargstarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 115 then
--|#line 485 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 485")
end

create yyval3.make (Fargpluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 116 then
--|#line 487 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 487")
end

create yyval3.make (Fargpluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 117 then
--|#line 492 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 492")
end

create yyval3.make (FArg); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 118 then
--|#line 494 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 494")
end

create yyval3.make (FArg); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 119 then
--|#line 499 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 499")
end

create yyval3.make (FArgName); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 120 then
--|#line 504 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 504")
end

create yyval3.make (AxiomDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(AXIOMKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 121 then
--|#line 509 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 509")
end

create yyval3.make (VarDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(VARKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 122 then
--|#line 514 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 514")
end

create yyval3.make (IdsTypeWherepluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 123 then
--|#line 516 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 516")
end

create yyval3.make (IdsTypeWherepluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 124 then
--|#line 521 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 521")
end

create yyval3.make (IdsTypeWherestarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 125 then
--|#line 523 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 523")
end

create yyval3.make (IdsTypeWherestarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 126 then
--|#line 528 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 528")
end

create yyval3.make (IdsTypeWhere); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 127 then
--|#line 530 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 530")
end

create yyval3.make (IdsTypeWhere); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 128 then
--|#line 535 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 535")
end

create yyval3.make (WhereClause); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(WHEREKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 129 then
--|#line 540 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 540")
end

create yyval3.make (ProcedureDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(PROCEDUREKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 130 then
--|#line 542 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 542")
end

create yyval3.make (ProcedureDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(PROCEDUREKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3 - 3)); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -3
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 131 then
--|#line 547 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 547")
end

create yyval3.make (Specstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 132 then
--|#line 549 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 549")
end

create yyval3.make (Specstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 133 then
--|#line 554 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 554")
end

create yyval3.make (Bodystar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 134 then
--|#line 556 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 556")
end

create yyval3.make (Bodystar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 135 then
--|#line 561 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 561")
end

create yyval3.make (PSig); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 136 then
--|#line 563 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 563")
end

create yyval3.make (PSig); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 137 then
--|#line 565 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 565")
end

create yyval3.make (PSig); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 138 then
--|#line 567 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 567")
end

create yyval3.make (PSig); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 139 then
--|#line 572 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 572")
end

create yyval3.make (OutParameters); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(RETURNSKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 140 then
--|#line 577 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 577")
end

create yyval3.make (Spec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(REQUIRESKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 141 then
--|#line 579 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 579")
end

create yyval3.make (Spec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FREEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(REQUIRESKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 142 then
--|#line 581 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 581")
end

create yyval3.make (Spec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(MODIFIESKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 143 then
--|#line 583 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 583")
end

create yyval3.make (Spec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FREEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(MODIFIESKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 144 then
--|#line 585 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 585")
end

create yyval3.make (Spec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ENSURESKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 145 then
--|#line 587 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 587")
end

create yyval3.make (Spec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FREEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ENSURESKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 146 then
--|#line 592 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 592")
end

create yyval3.make (Idstarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 147 then
--|#line 594 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 594")
end

create yyval3.make (Idstarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 148 then
--|#line 599 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 599")
end

create yyval3.make (ImplementationDecl); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(IMPLEMENTATIONKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 149 then
--|#line 604 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 604")
end

create yyval3.make (ISig); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 150 then
--|#line 606 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 606")
end

create yyval3.make (ISig); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 151 then
--|#line 608 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 608")
end

create yyval3.make (ISig); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 152 then
--|#line 610 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 610")
end

create yyval3.make (ISig); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 153 then
--|#line 615 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 615")
end

create yyval3.make (OutParams); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(RETURNSKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 154 then
--|#line 620 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 620")
end

create yyval3.make (IdsTypestarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 155 then
--|#line 622 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 622")
end

create yyval3.make (IdsTypestarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 156 then
--|#line 627 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 627")
end

create yyval3.make (Body); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CURLYOPENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CURLYCLOSEDKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 157 then
--|#line 632 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 632")
end

create yyval3.make (LocalVarDeclstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 158 then
--|#line 634 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 634")
end

create yyval3.make (LocalVarDeclstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 159 then
--|#line 639 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 639")
end

create yyval3.make (LocalVarDecl); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 160 then
--|#line 644 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 644")
end

create yyval3.make (StmtList); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 161 then
--|#line 646 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 646")
end

create yyval3.make (StmtList); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 162 then
--|#line 651 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 651")
end

create yyval3.make (LStmtstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 163 then
--|#line 653 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 653")
end

create yyval3.make (LStmtstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 164 then
--|#line 658 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 658")
end

create yyval3.make (LStmt); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 165 then
--|#line 660 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 660")
end

create yyval3.make (LStmt); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COLONKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 166 then
--|#line 665 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 665")
end

create yyval3.make (LEmpty); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 167 then
--|#line 667 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 667")
end

create yyval3.make (LEmpty); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COLONKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 168 then
--|#line 672 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 672")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ASSERTKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 169 then
--|#line 674 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 674")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ASSUMEKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 170 then
--|#line 676 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 676")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(HAVOCKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 171 then
--|#line 678 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 678")
end

create yyval3.make (Stmt); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ASSIGNEMENTKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 172 then
--|#line 680 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 680")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CALLKW, yyvs2.item (yyvsp2 - 3))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 173 then
--|#line 682 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 682")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CALLKW, yyvs2.item (yyvsp2 - 3))); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 174 then
--|#line 684 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 684")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CALLKW, yyvs2.item (yyvsp2 - 4))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FORALLKW, yyvs2.item (yyvsp2 - 3))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -5
	yyvs3.put (yyval3, yyvsp3)
end
when 175 then
--|#line 686 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 686")
end

create yyval3.make (Stmt); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 176 then
--|#line 688 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 688")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(WHILEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 177 then
--|#line 690 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 690")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(BREAKKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 178 then
--|#line 692 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 692")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(BREAKKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 179 then
--|#line 694 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 694")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(RETURNKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 180 then
--|#line 696 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 696")
end

create yyval3.make (Stmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(GOTOKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 181 then
--|#line 701 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 701")
end

create yyval3.make (Lhspluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 182 then
--|#line 703 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 703")
end

create yyval3.make (Lhspluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 183 then
--|#line 708 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 708")
end

create yyval3.make (Lhs); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 184 then
--|#line 713 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 713")
end

create yyval3.make (MapSelectstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 185 then
--|#line 715 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 715")
end

create yyval3.make (MapSelectstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 186 then
--|#line 720 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 720")
end

create yyval3.make (MapSelect); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENBRACKETKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDBRACKETKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 187 then
--|#line 725 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 725")
end

create yyval3.make (CallLhs); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ASSIGNEMENTKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 188 then
--|#line 730 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 730")
end

create yyval3.make (WildcardExprstarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 189 then
--|#line 732 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 732")
end

create yyval3.make (WildcardExprstarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 190 then
--|#line 737 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 737")
end

create yyval3.make (WildcardExprpluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 191 then
--|#line 739 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 739")
end

create yyval3.make (WildcardExprpluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 192 then
--|#line 744 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 744")
end

create yyval3.make (WildcardExpr); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 193 then
--|#line 746 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 746")
end

create yyval3.make (WildcardExpr); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(TIMESKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 194 then
--|#line 751 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 751")
end

create yyval3.make (BlockStmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CURLYOPENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CURLYCLOSEDKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 195 then
--|#line 756 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 756")
end

create yyval3.make (IfStmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(IFKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 196 then
--|#line 758 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 758")
end

create yyval3.make (IfStmt); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(IFKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(OPENPARENKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3 - 2)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(CLOSEDPARENKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -2
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 197 then
--|#line 763 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 763")
end

create yyval3.make (Elsepart); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ELSEKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 198 then
--|#line 765 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 765")
end

create yyval3.make (Elsepart); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(ELSEKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 199 then
--|#line 770 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 770")
end

create yyval3.make (LoopInvstar); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 200 then
--|#line 772 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 772")
end

create yyval3.make (LoopInvstar); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 201 then
--|#line 777 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 777")
end

create yyval3.make (LoopInv); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(INVARIANTKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 202 then
--|#line 779 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 779")
end

create yyval3.make (LoopInv); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(FREEKW, yyvs2.item (yyvsp2 - 2))); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(INVARIANTKW, yyvs2.item (yyvsp2 - 1))); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(SEMICOLONKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 203 then
--|#line 784 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 784")
end

create yyval3.make (OrderSpec); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 204 then
--|#line 786 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 786")
end

create yyval3.make (OrderSpec); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 205 then
--|#line 788 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 788")
end

create yyval3.make (OrderSpec); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMPLETEKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 206 then
--|#line 790 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 790")
end

create yyval3.make (OrderSpec); yyval3.add_child (yyvs3.item (yyvsp3)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMPLETEKW, yyvs2.item (yyvsp2))); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 207 then
--|#line 795 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 795")
end

create yyval3.make (ParentInfo); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(PRECEDESKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 208 then
--|#line 800 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 800")
end

create yyval3.make (ParentEdgestarcomma); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp3 := yyvsp3 + 1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 209 then
--|#line 802 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 802")
end

create yyval3.make (ParentEdgestarcomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 210 then
--|#line 807 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 807")
end

create yyval3.make (ParentEdgepluscomma); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 211 then
--|#line 809 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 809")
end

create yyval3.make (ParentEdgepluscomma); yyval3.add_child (yyvs3.item (yyvsp3 - 1)); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(COMMAKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 212 then
--|#line 814 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 814")
end

create yyval3.make (ParentEdge); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 213 then
--|#line 816 "mod_boogiepl.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'mod_boogiepl.y' at line 816")
end

create yyval3.make (ParentEdge); yyval3.add_child(create {PRODUCTION_CLASS}.make_with_value(UNIQUEKW, yyvs2.item (yyvsp2))); yyval3.add_child (yyvs3.item (yyvsp3)); 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_error_action (yy_act: INTEGER) is
			-- Execute error action.
		do
			inspect yy_act
			when 377 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER] is
			-- Template for `yytranslate'
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68, yyDummy>>)
		end

	yyr1_template: SPECIAL [INTEGER] is
			-- Template for `yyr1'
		once
			Result := yyfixed_array (<<
			    0,   69,   70,   70,   71,   71,   71,   71,   71,   71,
			   71,   72,   73,   73,   74,   74,   75,   75,   75,   76,
			   76,   77,   78,   78,   79,   80,   81,   82,   82,   83,
			   84,   84,   85,   85,   86,   87,   88,   88,   89,   89,
			   90,   90,   91,   91,   92,   93,   94,   94,   94,   94,
			   94,   94,   94,   94,   94,   95,   95,   96,   97,   98,
			   98,   99,  100,  101,  101,  102,  102,  103,  103,  103,
			  104,  104,  105,  106,  107,  107,  107,  107,  107,  107,
			  107,  108,  108,  109,  110,  110,  111,  111,  112,  112,
			  113,  113,  113,  113,  114,  114,  114,  115,  115,  116,

			  116,  117,  117,  117,  117,  117,  118,  119,  119,  120,
			  120,  121,  121,  122,  122,  123,  123,  124,  124,  125,
			  126,  127,  128,  128,  129,  129,  130,  130,  131,  132,
			  132,  133,  133,  134,  134,  135,  135,  135,  135,  136,
			  137,  137,  137,  137,  137,  137,  138,  138,  139,  140,
			  140,  140,  140,  141,  142,  142,  143,  144,  144,  145,
			  146,  146,  147,  147,  148,  148,  149,  149,  150,  150,
			  150,  150,  150,  150,  150,  150,  150,  150,  150,  150,
			  150,  151,  151,  152,  153,  153,  154,  155,  156,  156,
			  157,  157,  158,  158,  159,  160,  160,  161,  161,  162,

			  162,  163,  163,  164,  164,  164,  164,  165,  166,  166,
			  167,  167,  168,  168, yyDummy>>)
		end

	yytypes1_template: SPECIAL [INTEGER] is
			-- Template for `yytypes1'
		once
			Result := yyfixed_array (<<
			    3,    3,    2,    2,    2,    2,    2,    2,    2,    3,
			    3,    3,    3,    3,    3,    3,    3,    3,    3,    2,
			    3,    3,    3,    3,    3,    2,    3,    3,    3,    3,
			    3,    2,    3,    3,    3,    3,    3,    3,    3,    3,
			    3,    3,    3,    2,    2,    2,    3,    2,    2,    3,
			    2,    2,    3,    2,    2,    3,    3,    2,    3,    3,
			    2,    3,    3,    3,    2,    2,    3,    3,    2,    2,
			    3,    2,    3,    2,    2,    3,    3,    3,    3,    3,
			    3,    2,    2,    2,    2,    2,    2,    2,    3,    2,
			    2,    3,    2,    2,    2,    3,    2,    2,    2,    2,

			    2,    2,    2,    3,    3,    3,    3,    3,    2,    2,
			    2,    2,    3,    3,    3,    3,    3,    3,    3,    3,
			    2,    3,    3,    3,    3,    2,    2,    3,    3,    3,
			    3,    2,    3,    3,    3,    3,    3,    3,    3,    2,
			    2,    2,    3,    2,    3,    3,    3,    3,    2,    2,
			    3,    3,    3,    3,    3,    3,    3,    3,    3,    2,
			    2,    3,    3,    2,    3,    2,    3,    3,    3,    3,
			    3,    3,    3,    3,    2,    2,    2,    2,    3,    3,
			    2,    2,    2,    2,    2,    3,    3,    2,    2,    3,
			    3,    2,    2,    2,    3,    3,    3,    2,    3,    2,

			    2,    3,    3,    3,    2,    3,    3,    3,    3,    2,
			    2,    2,    3,    3,    3,    2,    3,    2,    3,    3,
			    3,    3,    2,    2,    2,    3,    3,    2,    3,    2,
			    2,    3,    2,    2,    3,    2,    3,    3,    2,    3,
			    2,    2,    3,    3,    2,    2,    3,    3,    3,    3,
			    3,    2,    2,    3,    3,    3,    2,    2,    3,    2,
			    2,    3,    3,    2,    2,    3,    3,    3,    3,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    3,
			    3,    3,    3,    3,    3,    3,    2,    2,    2,    3,
			    3,    2,    2,    3,    3,    2,    2,    2,    2,    2,

			    3,    3,    2,    3,    3,    3,    2,    3,    3,    3,
			    2,    3,    2,    2,    2,    2,    3,    2,    2,    3,
			    3,    3,    2,    2,    3,    2,    2,    3,    2,    2,
			    2,    3,    3,    2,    3,    3,    3,    3,    2,    2,
			    2,    2,    3,    2,    3,    2,    3,    2,    3,    3,
			    3,    3,    2,    3,    2,    2,    2,    3,    3,    3,
			    2,    3,    2,    2,    2,    2,    3,    2,    2,    3,
			    3,    2,    3,    2,    2,    3,    2,    3,    1,    1, yyDummy>>)
		end

	yytypes2_template: SPECIAL [INTEGER] is
			-- Template for `yytypes2'
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER] is
			-- Template for `yydefact'
		once
			Result := yyfixed_array (<<
			    2,    1,    0,    0,    0,    0,    0,    0,   63,    3,
			    4,   84,   85,    5,    6,    7,    8,    9,   10,   58,
			   59,    0,  126,    0,  122,    0,   88,    0,    0,    0,
			    0,    0,  203,    0,   11,   12,   14,   16,   27,   29,
			   30,   32,    0,    0,    0,   63,  127,  121,    0,    0,
			    0,   86,   89,    0,  124,    0,  131,  154,    0,  133,
			  113,    0,    0,  203,  208,  205,    0,  204,  120,   72,
			   63,   73,   63,   25,   26,   17,   19,   18,   22,   63,
			   63,   80,   79,   78,   77,   76,   75,   74,   63,   66,
			   65,   63,   69,   68,   67,   63,   70,   71,   45,   63,

			   47,    0,   46,   34,   48,   36,   49,   64,    0,    0,
			   95,   94,   92,    0,   62,   90,   91,   60,  128,  123,
			   87,    0,    0,  125,    0,  124,  131,    0,  155,   55,
			    0,  154,  148,   92,  117,    0,  114,  115,    0,  113,
			   63,  109,    0,    0,  212,  207,  209,  210,  107,  206,
			   13,   15,   20,   23,   21,   24,   28,   31,   33,   82,
			   81,    0,    0,   63,   35,   63,   50,    0,   99,    0,
			  103,  101,  105,   93,    0,  106,   61,  137,    0,  129,
			  157,   63,  146,    0,   63,  132,  130,    0,  149,    0,
			  134,  119,    0,    0,  118,    0,    0,  108,  213,    0,

			   54,    0,    0,    0,   63,   37,   40,   43,    0,   96,
			    0,    0,  104,  102,    0,    0,  138,  135,  162,    0,
			  147,    0,   63,  146,   63,    0,   56,    0,  152,  150,
			    0,  116,    0,  110,  211,   83,   63,    0,   51,    0,
			   63,   57,  100,   97,    0,  124,  136,  159,  158,    0,
			  160,  140,  142,    0,    0,    0,  144,  154,  151,    0,
			    0,    0,   63,   38,   63,    0,   41,   98,    0,  156,
			    0,    0,    0,    0,    0,    0,    0,   63,   63,  184,
			  163,  161,  164,    0,  181,  175,  141,  143,  145,    0,
			    0,    0,   52,    0,   44,   39,  139,   63,  179,   63,

			    0,    0,    0,   59,    0,    0,  177,    0,    0,    0,
			  166,  183,    0,   63,  153,  111,    0,   53,  193,  192,
			    0,    0,  170,  180,    0,   63,  187,    0,  178,  169,
			  168,  165,  167,   63,  185,  184,  182,    0,  112,  199,
			    0,  188,    0,   63,    0,  171,    0,  162,  195,    0,
			  189,  190,    0,    0,  186,   63,    0,  176,  200,    0,
			    0,  196,    0,   63,  172,    0,    0,   63,  194,  197,
			  198,  174,  191,  173,  201,    0,  202,    0,    0,    0, yyDummy>>)
		end

	yydefgoto_template: SPECIAL [INTEGER] is
			-- Template for `yydefgoto'
		once
			Result := yyfixed_array (<<
			  377,    1,    9,  206,   34,   35,   36,   75,   76,   77,
			   78,   79,   80,   37,   38,   39,   40,   41,  103,  164,
			  205,  207,  208,  265,  104,  105,  128,  166,   20,   21,
			  113,   22,   42,   91,   95,  107,   70,   72,   88,  162,
			  236,   10,   11,   27,  134,  115,  116,  169,  173,   12,
			   13,   14,   62,  135,  136,  137,  138,   15,   16,  123,
			  124,   24,   46,   17,  127,  132,   56,  216,  185,  221,
			   18,   59,  228,  130,  186,  218,  248,  249,  250,  280,
			  281,  282,  283,  284,  311,  334,  305,  349,  350,  320,
			  348,  285,  361,  346,  358,   66,   67,  145,  146,  147, yyDummy>>)
		end

	yypact_template: SPECIAL [INTEGER] is
			-- Template for `yypact'
		once
			Result := yyfixed_array (<<
			 -32768,  176,  203,   11,  203,  203,  203,   61, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  172,  303,  167, -32768,  203, -32768,  145,   60,   59,
			   30,  203,    6,  293, -32768,  292,  282,  184,  108,  173,
			  157, -32768,   57,   69,  203, -32768, -32768, -32768,  203,  161,
			   69, -32768, -32768,  203,  203,  291,  290,  203,  289, -32768,
			   69,  288,  138,    6,   16, -32768,  287,  316, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  277, -32768,  247, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  183,

			 -32768,  285, -32768, -32768, -32768, -32768,  284, -32768,   69,   69,
			 -32768, -32768,   69,  286, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  274,    2,  283,  280,  203, -32768,    8,  281, -32768,
			  278,  203,  273,   27, -32768,  275,  276, -32768,   69,   69,
			 -32768, -32768,  270,  203, -32768, -32768,  272, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,  157, -32768, -32768,
			 -32768,  269,   78, -32768,  266,  199, -32768,  268, -32768,  189,
			   69,   69, -32768, -32768,   69, -32768, -32768,  260,  265,  107,
			 -32768, -32768,  203,  130, -32768, -32768, -32768,  203,  256,  264,
			 -32768, -32768,  271,   69, -32768,  261,  262, -32768, -32768,   16,

			 -32768,   47,  203,  258, -32768, -32768, -32768,  259,  255, -32768,
			   69,   69, -32768, -32768,  187,  257, -32768,  260,  254,  252,
			  249,  251, -32768,  203, -32768,  248, -32768,  246, -32768,  256,
			  244, -32768,  245, -32768, -32768, -32768, -32768,   47, -32768,  182,
			 -32768, -32768, -32768, -32768,   69,  203, -32768, -32768, -32768,  236,
			  143, -32768, -32768,  240,  238,  237, -32768,  203, -32768,   69,
			  239,  235, -32768, -32768, -32768,  231, -32768, -32768,  234, -32768,
			  233,  229,  228,  203,  203,  149,   55, -32768, -32768,  222,
			 -32768, -32768, -32768,  119, -32768, -32768, -32768, -32768, -32768,  226,
			  225,   69, -32768,  224, -32768, -32768, -32768,   38, -32768,   38,

			  155,  136,  203,  223,  114,  203, -32768,  219,  217,  216,
			  143,  221,  203, -32768, -32768, -32768,  215, -32768, -32768, -32768,
			  212,  210, -32768, -32768,  209,  199, -32768,  208, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,   99, -32768, -32768,
			  202,   25,  204,  199,   91, -32768,   14, -32768,  193,  175,
			  164, -32768,  117,  150, -32768, -32768,  101, -32768, -32768,   98,
			   -3, -32768,   72,   38, -32768,   52,   13, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,  -12, -32768,   35,   22, -32768, yyDummy>>)
		end

	yypgoto_template: SPECIAL [INTEGER] is
			-- Template for `yypgoto'
		once
			Result := yyfixed_array (<<
			 -32768, -32768, -32768,   -8,  299,  298, -32768, -32768,  297, -32768,
			  296, -32768, -32768,  163,  295, -32768,  294,  267, -32768, -32768,
			 -32768, -202, -225, -32768, -32768, -32768, -143, -32768,    1,  -44,
			  -17,   -4, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			  121, -32768, -32768,  329,  -26,  -91,  -94,  178,   70, -32768,
			 -32768, -32768, -32768,  218, -32768, -185, -32768, -32768,  133,  348,
			 -124,  301, -32768, -32768,  227, -32768, -32768,  131, -32768,  123,
			 -32768, -32768,  115, -121,  213, -32768, -32768,   -7, -32768,   33,
			   29, -32768, -32768,   26, -32768, -32768, -32768, -32768, -32768, -285,
			 -314,  -23, -32768, -32768, -32768,  279, -32768, -32768, -32768,  127, yyDummy>>)
		end

	yytable_template: SPECIAL [INTEGER] is
			-- Template for `yytable'
		once
			Result := yyfixed_array (<<
			   33,  178,  239,   32,   26,   28,   29,   30,  231,  122,
			  189,   55,   58,   61,  321,   65,  272,  114,  172,  201,
			  184,  171,  379,  183,  121,   25,   26,   63,   52,  356,
			  376,  182,  357,  111,  181,  378,  355,  118,  -63,  172,
			   44,  347,  171,  106,  112,  117,  369,  143,  110,  -63,
			   52,  112,  180,  129,  -63,  374,  351,   19,  347,  237,
			  176,  133,   19,  109,  -63,  144,  108,   64,  191,   60,
			  102,  -63,  -63,   19,  290,  111,  172,  172,  372,  171,
			  171,  101,  167,  168,   53,  187,  100,   53,  -63,  318,
			  110,  161,   31,  -63,  373,  235,   99,  306,   57,   54,

			  342,   19,  318,   19,   98,  109,  316,   19,  108,  112,
			  112,  337,  194,  170,  371,   19,   53,   53,  353,  184,
			   97,  268,  183,  367,   19,   96,   53,  129,  354,  240,
			  182,  344,  196,  181,  170,   53,  289,  240,  220,  112,
			  133,  345,  224,  368,  198,  202,  278,  277,  168,  326,
			  276,  275,   44,  223,  313,  203,  222,  312,  129,  364,
			  274,  273,  272,   87,   86,   85,   84,   83,   82,   81,
			  271,  170,  170,  219,   44,  112,  225,  270,  323,  220,
			  141,    8,  140,  226,  242,  243,    7,   51,   50,   19,
			  365,   19,    6,   44,  133,   19,    5,  322,  129,  302,

			  144,    4,  363,  120,  360,   48,    3,   19,    2,   47,
			   44,  112,  112,   43,  253,  362,  255,  264,  267,  263,
			  240,   94,   93,   92,  244,  210,  211,  210,  261,  300,
			  301,  304,  266,  160,  159,   90,   89,   74,   73,  -42,
			  212,  213,  154,  155,  352,  112,  347,  343,  341,   19,
			  340,  279,  339,  129,  293,  338,  294,  333,  330,  329,
			  133,  328,  325,  310,  317,  315,  314,  299,  295,  308,
			  309,  298,  297,  260,  296,  292,  303,  307,  291,  288,
			  287,  269,  286,  259,  227,  257,    2,   44,  215,  319,
			  256,  319,  133,  252,  251,  241,  245,  240,  238,  230,

			   74,  232,  204,  324,  229,  217,  327,  233,  209,  200,
			  199,  279,  197,  335,  193,  192,  175,  180,  188,  187,
			  177,   48,  174,  165,  163,  149,  234,  139,  131,  148,
			  125,   73,  126,  319,   71,   68,   45,  370,  336,  332,
			  359,   69,  142,  331,  258,  190,  254,  366,  246,  119,
			   23,  247,  214,  179,   49,  319,    0,  195,  262,  375,
			    0,    0,  158,    0,    0,    0,    0,    0,    0,  150,
			  151,    0,  152,  153,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  156,    0,  157, yyDummy>>)
		end

	yycheck_template: SPECIAL [INTEGER] is
			-- Template for `yycheck'
		once
			Result := yyfixed_array (<<
			    8,  125,  204,    7,    3,    4,    5,    6,  193,   53,
			  131,   28,   29,   30,  299,    9,   19,   43,  112,  162,
			   12,  112,    0,   15,   50,   14,   25,   31,   27,   15,
			   42,   23,  346,    6,   26,    0,   22,   45,   13,  133,
			   38,   44,  133,   42,   43,   44,  360,   31,   21,   24,
			   49,   50,   44,   57,   29,   42,  341,   46,   44,  202,
			   58,   60,   46,   36,   39,   64,   39,   61,   41,   39,
			   13,   46,   47,   46,  259,    6,  170,  171,  363,  170,
			  171,   24,  108,  109,   57,   38,   29,   57,   63,   64,
			   21,   99,   31,   68,   42,   48,   39,   42,   39,   39,

			  325,   46,   64,   46,   47,   36,  291,   46,   39,  108,
			  109,  313,  138,  112,   42,   46,   57,   57,  343,   12,
			   63,  245,   15,   22,   46,   68,   57,  131,   37,   38,
			   23,  333,  140,   26,  133,   57,  257,   38,  182,  138,
			  139,   42,   12,   45,  143,  162,    3,    4,  174,   35,
			    7,    8,   38,   23,   35,  163,   26,   38,  162,   42,
			   17,   18,   19,   55,   56,   57,   58,   59,   60,   61,
			   27,  170,  171,  181,   38,  174,  184,   34,   42,  223,
			   42,    5,   44,  187,  210,  211,   10,   42,   43,   46,
			   40,   46,   16,   38,  193,   46,   20,   42,  202,   50,

			  199,   25,   38,   42,   11,   38,   30,   46,   32,   42,
			   38,  210,  211,   41,  222,   40,  224,   35,  244,   37,
			   38,   64,   65,   66,   37,   38,   37,   38,  236,  273,
			  274,  275,  240,   50,   51,   62,   63,   53,   54,   40,
			  170,  171,   79,   80,   40,  244,   44,   39,   39,   46,
			   40,  250,   40,  257,  262,   40,  264,   36,   42,   42,
			  259,   42,   39,   41,   40,   40,   40,   39,   37,  277,
			  278,   42,   39,   28,   40,   40,  275,  276,   39,   42,
			   42,   45,   42,   39,   28,   39,   32,   38,   28,  297,
			   42,  299,  291,   42,   42,   40,   39,   38,   40,   28,

			   53,   40,   36,  302,   40,   40,  305,   45,   40,   40,
			   38,  310,   42,  312,   38,   40,   42,   44,   40,   38,
			   40,   38,   36,   39,   39,    9,  199,   39,   39,   42,
			   39,   54,   42,  341,   52,   42,   33,  360,  312,  310,
			  347,   49,   63,  310,  229,  132,  223,  355,  217,   48,
			    2,  218,  174,  126,   25,  363,   -1,  139,  237,  367,
			   -1,   -1,   95,   -1,   -1,   -1,   -1,   -1,   -1,   70,
			   72,   -1,   75,   77,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   88,   -1,   91, yyDummy>>)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [ANY]
			-- Stack for semantic values of type ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [ANY]
			-- Routines that ought to be in SPECIAL [ANY]

	yyvs2: SPECIAL [STRING]
			-- Stack for semantic values of type STRING

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [STRING]
			-- Routines that ought to be in SPECIAL [STRING]

	yyvs3: SPECIAL [PRODUCTION_CLASS]
			-- Stack for semantic values of type PRODUCTION_CLASS

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [PRODUCTION_CLASS]
			-- Routines that ought to be in SPECIAL [PRODUCTION_CLASS]

feature {NONE} -- Constants

	yyFinal: INTEGER is 379
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 69
			-- Number of tokens

	yyLast: INTEGER is 385
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 323
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 169
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features





feature {NONE}  -- Initialization

	make  (filename: STRING) is
			-- Create a new parser and parse filename
      do
			make_scanner(filename)
			make_parser_skeleton
			create error_messages.make
			parse
		end
	
	
	
feature -- Access

   error_messages: LINKED_LIST [STRING]
			-- Error messages reported so far
	
	parse_tree: PRODUCTION_CLASS 
	
	
feature {NONE}  -- Error reporting

   report_error (a_message: STRING) is
          -- Store error messages in error_messages
      do
         error_messages.extend (a_message)
		end

end
